#ifndef FLYDIRDIALOG_H
#define FLYDIRDIALOG_H

#include <QObject>

#include "idirdialog.h"
#include "flyfiledialog_global.h"

class FLY_FILEDIALOG_EXPORT FlyDirDialog : public QObject, LibFlyFileDialog::IDirDialog
{
    Q_OBJECT
public:
    explicit FlyDirDialog(QWidget *parent = 0,
                          const QString &caption = QString(),
                          const QString &directory = QString());

    ~FlyDirDialog();

    void setDirectory(const QString &directory) Q_DECL_OVERRIDE;
    QString directory() const Q_DECL_OVERRIDE;

    QStringList selectedDirs() const Q_DECL_OVERRIDE;

    void setSidebarUrls(const QList<QUrl> & urls) Q_DECL_OVERRIDE;
    QList<QUrl> sidebarUrls() const Q_DECL_OVERRIDE;

    void setVisible(bool visible) Q_DECL_OVERRIDE;

    void setShowOptions(Qt::WindowFlags windowFlags,
                        Qt::WindowModality windowModality,
                        QWindow *parent) Q_DECL_OVERRIDE;

    QString windowTitle() const Q_DECL_OVERRIDE;

public Q_SLOTS:
    void setWindowTitle(const QString &) Q_DECL_OVERRIDE;
    int exec() Q_DECL_OVERRIDE;

Q_SIGNALS:
    void currentUrlChanged(const QUrl & url);
    void directoryUrlEntered(const QUrl & directory);
    void urlSelected(const QUrl & url);
    void urlsSelected(const QList<QUrl> & urls);
    void filterSelected(const QString & filter);
    void accepted();
    void rejected();

private:
    static LibFlyFileDialog::IDirDialog* createDirDialog(QWidget *parent = 0);
    LibFlyFileDialog::IDirDialog* dirDialog;
};

#endif // FLYDIRDIALOG_H
